#ifndef _H_9A1BC794C1C89EA7578C58D539B4168D_UdpPacket_DCPS_H_
#define _H_9A1BC794C1C89EA7578C58D539B4168D_UdpPacket_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "UdpPacket_.h"


namespace udp_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class UdpPacket_TypeSupportInterface;

            typedef UdpPacket_TypeSupportInterface * UdpPacket_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UdpPacket_TypeSupportInterface> UdpPacket_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UdpPacket_TypeSupportInterface> UdpPacket_TypeSupportInterface_out;


            class UdpPacket_DataWriter;

            typedef UdpPacket_DataWriter * UdpPacket_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UdpPacket_DataWriter> UdpPacket_DataWriter_var;
            typedef DDS_DCPSInterface_out < UdpPacket_DataWriter> UdpPacket_DataWriter_out;


            class UdpPacket_DataReader;

            typedef UdpPacket_DataReader * UdpPacket_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UdpPacket_DataReader> UdpPacket_DataReader_var;
            typedef DDS_DCPSInterface_out < UdpPacket_DataReader> UdpPacket_DataReader_out;


            class UdpPacket_DataReaderView;

            typedef UdpPacket_DataReaderView * UdpPacket_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UdpPacket_DataReaderView> UdpPacket_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UdpPacket_DataReaderView> UdpPacket_DataReaderView_out;

            struct UdpPacket_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < UdpPacket_, struct UdpPacket_Seq_uniq_> UdpPacket_Seq;
            typedef DDS_DCPSSequence_var < UdpPacket_Seq> UdpPacket_Seq_var;
            typedef DDS_DCPSSequence_out < UdpPacket_Seq> UdpPacket_Seq_out;

            class  UdpPacket_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UdpPacket_TypeSupportInterface_ptr _ptr_type;
                typedef UdpPacket_TypeSupportInterface_var _var_type;

                static UdpPacket_TypeSupportInterface_ptr _duplicate (UdpPacket_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpPacket_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UdpPacket_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpPacket_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpPacket_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UdpPacket_TypeSupportInterface () {};
                ~UdpPacket_TypeSupportInterface () {};
            private:
                UdpPacket_TypeSupportInterface (const UdpPacket_TypeSupportInterface &);
                UdpPacket_TypeSupportInterface & operator = (const UdpPacket_TypeSupportInterface &);
            };

            class  UdpPacket_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UdpPacket_DataWriter_ptr _ptr_type;
                typedef UdpPacket_DataWriter_var _var_type;

                static UdpPacket_DataWriter_ptr _duplicate (UdpPacket_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpPacket_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UdpPacket_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpPacket_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpPacket_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UdpPacket_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UdpPacket_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UdpPacket_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UdpPacket_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UdpPacket_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UdpPacket_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UdpPacket_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UdpPacket_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UdpPacket_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UdpPacket_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UdpPacket_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UdpPacket_& instance_data) = 0;

            protected:
                UdpPacket_DataWriter () {};
                ~UdpPacket_DataWriter () {};
            private:
                UdpPacket_DataWriter (const UdpPacket_DataWriter &);
                UdpPacket_DataWriter & operator = (const UdpPacket_DataWriter &);
            };

            class  UdpPacket_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UdpPacket_DataReader_ptr _ptr_type;
                typedef UdpPacket_DataReader_var _var_type;

                static UdpPacket_DataReader_ptr _duplicate (UdpPacket_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpPacket_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UdpPacket_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpPacket_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpPacket_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UdpPacket_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UdpPacket_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UdpPacket_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UdpPacket_& instance) = 0;

            protected:
                UdpPacket_DataReader () {};
                ~UdpPacket_DataReader () {};
            private:
                UdpPacket_DataReader (const UdpPacket_DataReader &);
                UdpPacket_DataReader & operator = (const UdpPacket_DataReader &);
            };

            class  UdpPacket_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UdpPacket_DataReaderView_ptr _ptr_type;
                typedef UdpPacket_DataReaderView_var _var_type;

                static UdpPacket_DataReaderView_ptr _duplicate (UdpPacket_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpPacket_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UdpPacket_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpPacket_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpPacket_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UdpPacket_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UdpPacket_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UdpPacket_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UdpPacket_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UdpPacket_& instance) = 0;

            protected:
                UdpPacket_DataReaderView () {};
                ~UdpPacket_DataReaderView () {};
            private:
                UdpPacket_DataReaderView (const UdpPacket_DataReaderView &);
                UdpPacket_DataReaderView & operator = (const UdpPacket_DataReaderView &);
            };
        }

    }

}

#endif
