#ifndef _H_F1E19C164EE6B3D2AB8F1D31E32428F2_UdpSend__H_
#define _H_F1E19C164EE6B3D2AB8F1D31E32428F2_UdpSend__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace udp_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  UdpSend_Request_
            {
                struct _data__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Octet, struct _data__seq_uniq_ > _data__seq;
                typedef DDS_DCPSSequence_var< _data__seq > _data__seq_var;
                typedef DDS_DCPSSequence_out< _data__seq > _data__seq_out;
                ::DDS::String_mgr local_address_;
                ::DDS::UShort local_port_;
                ::DDS::String_mgr remote_address_;
                ::DDS::UShort remote_port_;
                _data__seq data_;
            };

            typedef DDS_DCPSStruct_var<UdpSend_Request_> UdpSend_Request__var;
            typedef DDS_DCPSStruct_out < UdpSend_Request_> UdpSend_Request__out;

            struct  UdpSend_Response_
            {
                ::DDS::Boolean sent_;
            };

            typedef DDS_DCPSStruct_var<UdpSend_Response_> UdpSend_Response__var;
            typedef UdpSend_Response_& UdpSend_Response__out;

            struct  Sample_UdpSend_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::udp_msgs::srv::dds_::UdpSend_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_UdpSend_Request_> Sample_UdpSend_Request__var;
            typedef DDS_DCPSStruct_out < Sample_UdpSend_Request_> Sample_UdpSend_Request__out;

            struct  Sample_UdpSend_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::udp_msgs::srv::dds_::UdpSend_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_UdpSend_Response_> Sample_UdpSend_Response__var;
            typedef Sample_UdpSend_Response_& Sample_UdpSend_Response__out;

        }

    }

}

#endif /* _H_F1E19C164EE6B3D2AB8F1D31E32428F2_UdpSend__H_ */
