#ifndef _H_F1E19C164EE6B3D2AB8F1D31E32428F2_UdpSend_DCPS_H_
#define _H_F1E19C164EE6B3D2AB8F1D31E32428F2_UdpSend_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "UdpSend_.h"


namespace udp_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class UdpSend_Request_TypeSupportInterface;

            typedef UdpSend_Request_TypeSupportInterface * UdpSend_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UdpSend_Request_TypeSupportInterface> UdpSend_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UdpSend_Request_TypeSupportInterface> UdpSend_Request_TypeSupportInterface_out;


            class UdpSend_Request_DataWriter;

            typedef UdpSend_Request_DataWriter * UdpSend_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UdpSend_Request_DataWriter> UdpSend_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < UdpSend_Request_DataWriter> UdpSend_Request_DataWriter_out;


            class UdpSend_Request_DataReader;

            typedef UdpSend_Request_DataReader * UdpSend_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UdpSend_Request_DataReader> UdpSend_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < UdpSend_Request_DataReader> UdpSend_Request_DataReader_out;


            class UdpSend_Request_DataReaderView;

            typedef UdpSend_Request_DataReaderView * UdpSend_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UdpSend_Request_DataReaderView> UdpSend_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UdpSend_Request_DataReaderView> UdpSend_Request_DataReaderView_out;

            struct UdpSend_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < UdpSend_Request_, struct UdpSend_Request_Seq_uniq_> UdpSend_Request_Seq;
            typedef DDS_DCPSSequence_var < UdpSend_Request_Seq> UdpSend_Request_Seq_var;
            typedef DDS_DCPSSequence_out < UdpSend_Request_Seq> UdpSend_Request_Seq_out;

            class  UdpSend_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UdpSend_Request_TypeSupportInterface_ptr _ptr_type;
                typedef UdpSend_Request_TypeSupportInterface_var _var_type;

                static UdpSend_Request_TypeSupportInterface_ptr _duplicate (UdpSend_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpSend_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UdpSend_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpSend_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpSend_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UdpSend_Request_TypeSupportInterface () {};
                ~UdpSend_Request_TypeSupportInterface () {};
            private:
                UdpSend_Request_TypeSupportInterface (const UdpSend_Request_TypeSupportInterface &);
                UdpSend_Request_TypeSupportInterface & operator = (const UdpSend_Request_TypeSupportInterface &);
            };

            class  UdpSend_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UdpSend_Request_DataWriter_ptr _ptr_type;
                typedef UdpSend_Request_DataWriter_var _var_type;

                static UdpSend_Request_DataWriter_ptr _duplicate (UdpSend_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpSend_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UdpSend_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpSend_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpSend_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UdpSend_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UdpSend_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UdpSend_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UdpSend_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UdpSend_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UdpSend_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UdpSend_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UdpSend_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UdpSend_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UdpSend_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UdpSend_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UdpSend_Request_& instance_data) = 0;

            protected:
                UdpSend_Request_DataWriter () {};
                ~UdpSend_Request_DataWriter () {};
            private:
                UdpSend_Request_DataWriter (const UdpSend_Request_DataWriter &);
                UdpSend_Request_DataWriter & operator = (const UdpSend_Request_DataWriter &);
            };

            class  UdpSend_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UdpSend_Request_DataReader_ptr _ptr_type;
                typedef UdpSend_Request_DataReader_var _var_type;

                static UdpSend_Request_DataReader_ptr _duplicate (UdpSend_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpSend_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UdpSend_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpSend_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpSend_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UdpSend_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UdpSend_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UdpSend_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UdpSend_Request_& instance) = 0;

            protected:
                UdpSend_Request_DataReader () {};
                ~UdpSend_Request_DataReader () {};
            private:
                UdpSend_Request_DataReader (const UdpSend_Request_DataReader &);
                UdpSend_Request_DataReader & operator = (const UdpSend_Request_DataReader &);
            };

            class  UdpSend_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UdpSend_Request_DataReaderView_ptr _ptr_type;
                typedef UdpSend_Request_DataReaderView_var _var_type;

                static UdpSend_Request_DataReaderView_ptr _duplicate (UdpSend_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpSend_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UdpSend_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpSend_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpSend_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UdpSend_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UdpSend_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UdpSend_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UdpSend_Request_& instance) = 0;

            protected:
                UdpSend_Request_DataReaderView () {};
                ~UdpSend_Request_DataReaderView () {};
            private:
                UdpSend_Request_DataReaderView (const UdpSend_Request_DataReaderView &);
                UdpSend_Request_DataReaderView & operator = (const UdpSend_Request_DataReaderView &);
            };
            class UdpSend_Response_TypeSupportInterface;

            typedef UdpSend_Response_TypeSupportInterface * UdpSend_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UdpSend_Response_TypeSupportInterface> UdpSend_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UdpSend_Response_TypeSupportInterface> UdpSend_Response_TypeSupportInterface_out;


            class UdpSend_Response_DataWriter;

            typedef UdpSend_Response_DataWriter * UdpSend_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UdpSend_Response_DataWriter> UdpSend_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < UdpSend_Response_DataWriter> UdpSend_Response_DataWriter_out;


            class UdpSend_Response_DataReader;

            typedef UdpSend_Response_DataReader * UdpSend_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UdpSend_Response_DataReader> UdpSend_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < UdpSend_Response_DataReader> UdpSend_Response_DataReader_out;


            class UdpSend_Response_DataReaderView;

            typedef UdpSend_Response_DataReaderView * UdpSend_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UdpSend_Response_DataReaderView> UdpSend_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UdpSend_Response_DataReaderView> UdpSend_Response_DataReaderView_out;

            struct UdpSend_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < UdpSend_Response_, struct UdpSend_Response_Seq_uniq_> UdpSend_Response_Seq;
            typedef DDS_DCPSSequence_var < UdpSend_Response_Seq> UdpSend_Response_Seq_var;
            typedef DDS_DCPSSequence_out < UdpSend_Response_Seq> UdpSend_Response_Seq_out;

            class  UdpSend_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UdpSend_Response_TypeSupportInterface_ptr _ptr_type;
                typedef UdpSend_Response_TypeSupportInterface_var _var_type;

                static UdpSend_Response_TypeSupportInterface_ptr _duplicate (UdpSend_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpSend_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UdpSend_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpSend_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpSend_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UdpSend_Response_TypeSupportInterface () {};
                ~UdpSend_Response_TypeSupportInterface () {};
            private:
                UdpSend_Response_TypeSupportInterface (const UdpSend_Response_TypeSupportInterface &);
                UdpSend_Response_TypeSupportInterface & operator = (const UdpSend_Response_TypeSupportInterface &);
            };

            class  UdpSend_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UdpSend_Response_DataWriter_ptr _ptr_type;
                typedef UdpSend_Response_DataWriter_var _var_type;

                static UdpSend_Response_DataWriter_ptr _duplicate (UdpSend_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpSend_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UdpSend_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpSend_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpSend_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UdpSend_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UdpSend_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UdpSend_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UdpSend_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UdpSend_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UdpSend_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UdpSend_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UdpSend_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UdpSend_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UdpSend_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UdpSend_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UdpSend_Response_& instance_data) = 0;

            protected:
                UdpSend_Response_DataWriter () {};
                ~UdpSend_Response_DataWriter () {};
            private:
                UdpSend_Response_DataWriter (const UdpSend_Response_DataWriter &);
                UdpSend_Response_DataWriter & operator = (const UdpSend_Response_DataWriter &);
            };

            class  UdpSend_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UdpSend_Response_DataReader_ptr _ptr_type;
                typedef UdpSend_Response_DataReader_var _var_type;

                static UdpSend_Response_DataReader_ptr _duplicate (UdpSend_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpSend_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UdpSend_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpSend_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpSend_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UdpSend_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UdpSend_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UdpSend_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UdpSend_Response_& instance) = 0;

            protected:
                UdpSend_Response_DataReader () {};
                ~UdpSend_Response_DataReader () {};
            private:
                UdpSend_Response_DataReader (const UdpSend_Response_DataReader &);
                UdpSend_Response_DataReader & operator = (const UdpSend_Response_DataReader &);
            };

            class  UdpSend_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UdpSend_Response_DataReaderView_ptr _ptr_type;
                typedef UdpSend_Response_DataReaderView_var _var_type;

                static UdpSend_Response_DataReaderView_ptr _duplicate (UdpSend_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpSend_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UdpSend_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpSend_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpSend_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UdpSend_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UdpSend_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UdpSend_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UdpSend_Response_& instance) = 0;

            protected:
                UdpSend_Response_DataReaderView () {};
                ~UdpSend_Response_DataReaderView () {};
            private:
                UdpSend_Response_DataReaderView (const UdpSend_Response_DataReaderView &);
                UdpSend_Response_DataReaderView & operator = (const UdpSend_Response_DataReaderView &);
            };
            class Sample_UdpSend_Request_TypeSupportInterface;

            typedef Sample_UdpSend_Request_TypeSupportInterface * Sample_UdpSend_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_UdpSend_Request_TypeSupportInterface> Sample_UdpSend_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_UdpSend_Request_TypeSupportInterface> Sample_UdpSend_Request_TypeSupportInterface_out;


            class Sample_UdpSend_Request_DataWriter;

            typedef Sample_UdpSend_Request_DataWriter * Sample_UdpSend_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_UdpSend_Request_DataWriter> Sample_UdpSend_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_UdpSend_Request_DataWriter> Sample_UdpSend_Request_DataWriter_out;


            class Sample_UdpSend_Request_DataReader;

            typedef Sample_UdpSend_Request_DataReader * Sample_UdpSend_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_UdpSend_Request_DataReader> Sample_UdpSend_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_UdpSend_Request_DataReader> Sample_UdpSend_Request_DataReader_out;


            class Sample_UdpSend_Request_DataReaderView;

            typedef Sample_UdpSend_Request_DataReaderView * Sample_UdpSend_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_UdpSend_Request_DataReaderView> Sample_UdpSend_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_UdpSend_Request_DataReaderView> Sample_UdpSend_Request_DataReaderView_out;

            struct Sample_UdpSend_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_UdpSend_Request_, struct Sample_UdpSend_Request_Seq_uniq_> Sample_UdpSend_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_UdpSend_Request_Seq> Sample_UdpSend_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_UdpSend_Request_Seq> Sample_UdpSend_Request_Seq_out;

            class  Sample_UdpSend_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_UdpSend_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_UdpSend_Request_TypeSupportInterface_var _var_type;

                static Sample_UdpSend_Request_TypeSupportInterface_ptr _duplicate (Sample_UdpSend_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UdpSend_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UdpSend_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UdpSend_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UdpSend_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_UdpSend_Request_TypeSupportInterface () {};
                ~Sample_UdpSend_Request_TypeSupportInterface () {};
            private:
                Sample_UdpSend_Request_TypeSupportInterface (const Sample_UdpSend_Request_TypeSupportInterface &);
                Sample_UdpSend_Request_TypeSupportInterface & operator = (const Sample_UdpSend_Request_TypeSupportInterface &);
            };

            class  Sample_UdpSend_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_UdpSend_Request_DataWriter_ptr _ptr_type;
                typedef Sample_UdpSend_Request_DataWriter_var _var_type;

                static Sample_UdpSend_Request_DataWriter_ptr _duplicate (Sample_UdpSend_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UdpSend_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UdpSend_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UdpSend_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UdpSend_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_UdpSend_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_UdpSend_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_UdpSend_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_UdpSend_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_UdpSend_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_UdpSend_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_UdpSend_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_UdpSend_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_UdpSend_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_UdpSend_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_UdpSend_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UdpSend_Request_& instance_data) = 0;

            protected:
                Sample_UdpSend_Request_DataWriter () {};
                ~Sample_UdpSend_Request_DataWriter () {};
            private:
                Sample_UdpSend_Request_DataWriter (const Sample_UdpSend_Request_DataWriter &);
                Sample_UdpSend_Request_DataWriter & operator = (const Sample_UdpSend_Request_DataWriter &);
            };

            class  Sample_UdpSend_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_UdpSend_Request_DataReader_ptr _ptr_type;
                typedef Sample_UdpSend_Request_DataReader_var _var_type;

                static Sample_UdpSend_Request_DataReader_ptr _duplicate (Sample_UdpSend_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UdpSend_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UdpSend_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UdpSend_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UdpSend_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_UdpSend_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_UdpSend_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_UdpSend_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UdpSend_Request_& instance) = 0;

            protected:
                Sample_UdpSend_Request_DataReader () {};
                ~Sample_UdpSend_Request_DataReader () {};
            private:
                Sample_UdpSend_Request_DataReader (const Sample_UdpSend_Request_DataReader &);
                Sample_UdpSend_Request_DataReader & operator = (const Sample_UdpSend_Request_DataReader &);
            };

            class  Sample_UdpSend_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_UdpSend_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_UdpSend_Request_DataReaderView_var _var_type;

                static Sample_UdpSend_Request_DataReaderView_ptr _duplicate (Sample_UdpSend_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UdpSend_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UdpSend_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UdpSend_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UdpSend_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_UdpSend_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_UdpSend_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_UdpSend_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_UdpSend_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UdpSend_Request_& instance) = 0;

            protected:
                Sample_UdpSend_Request_DataReaderView () {};
                ~Sample_UdpSend_Request_DataReaderView () {};
            private:
                Sample_UdpSend_Request_DataReaderView (const Sample_UdpSend_Request_DataReaderView &);
                Sample_UdpSend_Request_DataReaderView & operator = (const Sample_UdpSend_Request_DataReaderView &);
            };
            class Sample_UdpSend_Response_TypeSupportInterface;

            typedef Sample_UdpSend_Response_TypeSupportInterface * Sample_UdpSend_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_UdpSend_Response_TypeSupportInterface> Sample_UdpSend_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_UdpSend_Response_TypeSupportInterface> Sample_UdpSend_Response_TypeSupportInterface_out;


            class Sample_UdpSend_Response_DataWriter;

            typedef Sample_UdpSend_Response_DataWriter * Sample_UdpSend_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_UdpSend_Response_DataWriter> Sample_UdpSend_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_UdpSend_Response_DataWriter> Sample_UdpSend_Response_DataWriter_out;


            class Sample_UdpSend_Response_DataReader;

            typedef Sample_UdpSend_Response_DataReader * Sample_UdpSend_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_UdpSend_Response_DataReader> Sample_UdpSend_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_UdpSend_Response_DataReader> Sample_UdpSend_Response_DataReader_out;


            class Sample_UdpSend_Response_DataReaderView;

            typedef Sample_UdpSend_Response_DataReaderView * Sample_UdpSend_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_UdpSend_Response_DataReaderView> Sample_UdpSend_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_UdpSend_Response_DataReaderView> Sample_UdpSend_Response_DataReaderView_out;

            struct Sample_UdpSend_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_UdpSend_Response_, struct Sample_UdpSend_Response_Seq_uniq_> Sample_UdpSend_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_UdpSend_Response_Seq> Sample_UdpSend_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_UdpSend_Response_Seq> Sample_UdpSend_Response_Seq_out;

            class  Sample_UdpSend_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_UdpSend_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_UdpSend_Response_TypeSupportInterface_var _var_type;

                static Sample_UdpSend_Response_TypeSupportInterface_ptr _duplicate (Sample_UdpSend_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UdpSend_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UdpSend_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UdpSend_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UdpSend_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_UdpSend_Response_TypeSupportInterface () {};
                ~Sample_UdpSend_Response_TypeSupportInterface () {};
            private:
                Sample_UdpSend_Response_TypeSupportInterface (const Sample_UdpSend_Response_TypeSupportInterface &);
                Sample_UdpSend_Response_TypeSupportInterface & operator = (const Sample_UdpSend_Response_TypeSupportInterface &);
            };

            class  Sample_UdpSend_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_UdpSend_Response_DataWriter_ptr _ptr_type;
                typedef Sample_UdpSend_Response_DataWriter_var _var_type;

                static Sample_UdpSend_Response_DataWriter_ptr _duplicate (Sample_UdpSend_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UdpSend_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UdpSend_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UdpSend_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UdpSend_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_UdpSend_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_UdpSend_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_UdpSend_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_UdpSend_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_UdpSend_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_UdpSend_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_UdpSend_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_UdpSend_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_UdpSend_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_UdpSend_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_UdpSend_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UdpSend_Response_& instance_data) = 0;

            protected:
                Sample_UdpSend_Response_DataWriter () {};
                ~Sample_UdpSend_Response_DataWriter () {};
            private:
                Sample_UdpSend_Response_DataWriter (const Sample_UdpSend_Response_DataWriter &);
                Sample_UdpSend_Response_DataWriter & operator = (const Sample_UdpSend_Response_DataWriter &);
            };

            class  Sample_UdpSend_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_UdpSend_Response_DataReader_ptr _ptr_type;
                typedef Sample_UdpSend_Response_DataReader_var _var_type;

                static Sample_UdpSend_Response_DataReader_ptr _duplicate (Sample_UdpSend_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UdpSend_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UdpSend_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UdpSend_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UdpSend_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_UdpSend_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_UdpSend_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_UdpSend_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UdpSend_Response_& instance) = 0;

            protected:
                Sample_UdpSend_Response_DataReader () {};
                ~Sample_UdpSend_Response_DataReader () {};
            private:
                Sample_UdpSend_Response_DataReader (const Sample_UdpSend_Response_DataReader &);
                Sample_UdpSend_Response_DataReader & operator = (const Sample_UdpSend_Response_DataReader &);
            };

            class  Sample_UdpSend_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_UdpSend_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_UdpSend_Response_DataReaderView_var _var_type;

                static Sample_UdpSend_Response_DataReaderView_ptr _duplicate (Sample_UdpSend_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UdpSend_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UdpSend_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UdpSend_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UdpSend_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_UdpSend_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_UdpSend_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_UdpSend_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_UdpSend_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UdpSend_Response_& instance) = 0;

            protected:
                Sample_UdpSend_Response_DataReaderView () {};
                ~Sample_UdpSend_Response_DataReaderView () {};
            private:
                Sample_UdpSend_Response_DataReaderView (const Sample_UdpSend_Response_DataReaderView &);
                Sample_UdpSend_Response_DataReaderView & operator = (const Sample_UdpSend_Response_DataReaderView &);
            };
        }

    }

}

#endif
