#ifndef _H_3BAD8698013C4D8D5DD39E6BEAA0FE56_UdpSocket__H_
#define _H_3BAD8698013C4D8D5DD39E6BEAA0FE56_UdpSocket__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace udp_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  UdpSocket_Request_
            {
                ::DDS::String_mgr local_address_;
                ::DDS::UShort local_port_;
                ::DDS::String_mgr remote_address_;
                ::DDS::UShort remote_port_;
                ::DDS::Boolean is_broadcast_;
            };

            typedef DDS_DCPSStruct_var<UdpSocket_Request_> UdpSocket_Request__var;
            typedef DDS_DCPSStruct_out < UdpSocket_Request_> UdpSocket_Request__out;

            struct  UdpSocket_Response_
            {
                ::DDS::Boolean socket_created_;
            };

            typedef DDS_DCPSStruct_var<UdpSocket_Response_> UdpSocket_Response__var;
            typedef UdpSocket_Response_& UdpSocket_Response__out;

            struct  Sample_UdpSocket_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::udp_msgs::srv::dds_::UdpSocket_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_UdpSocket_Request_> Sample_UdpSocket_Request__var;
            typedef DDS_DCPSStruct_out < Sample_UdpSocket_Request_> Sample_UdpSocket_Request__out;

            struct  Sample_UdpSocket_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::udp_msgs::srv::dds_::UdpSocket_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_UdpSocket_Response_> Sample_UdpSocket_Response__var;
            typedef Sample_UdpSocket_Response_& Sample_UdpSocket_Response__out;

        }

    }

}

#endif /* _H_3BAD8698013C4D8D5DD39E6BEAA0FE56_UdpSocket__H_ */
