#ifndef _H_3BAD8698013C4D8D5DD39E6BEAA0FE56_UdpSocket_DCPS_H_
#define _H_3BAD8698013C4D8D5DD39E6BEAA0FE56_UdpSocket_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "UdpSocket_.h"


namespace udp_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class UdpSocket_Request_TypeSupportInterface;

            typedef UdpSocket_Request_TypeSupportInterface * UdpSocket_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UdpSocket_Request_TypeSupportInterface> UdpSocket_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UdpSocket_Request_TypeSupportInterface> UdpSocket_Request_TypeSupportInterface_out;


            class UdpSocket_Request_DataWriter;

            typedef UdpSocket_Request_DataWriter * UdpSocket_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UdpSocket_Request_DataWriter> UdpSocket_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < UdpSocket_Request_DataWriter> UdpSocket_Request_DataWriter_out;


            class UdpSocket_Request_DataReader;

            typedef UdpSocket_Request_DataReader * UdpSocket_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UdpSocket_Request_DataReader> UdpSocket_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < UdpSocket_Request_DataReader> UdpSocket_Request_DataReader_out;


            class UdpSocket_Request_DataReaderView;

            typedef UdpSocket_Request_DataReaderView * UdpSocket_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UdpSocket_Request_DataReaderView> UdpSocket_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UdpSocket_Request_DataReaderView> UdpSocket_Request_DataReaderView_out;

            struct UdpSocket_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < UdpSocket_Request_, struct UdpSocket_Request_Seq_uniq_> UdpSocket_Request_Seq;
            typedef DDS_DCPSSequence_var < UdpSocket_Request_Seq> UdpSocket_Request_Seq_var;
            typedef DDS_DCPSSequence_out < UdpSocket_Request_Seq> UdpSocket_Request_Seq_out;

            class  UdpSocket_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UdpSocket_Request_TypeSupportInterface_ptr _ptr_type;
                typedef UdpSocket_Request_TypeSupportInterface_var _var_type;

                static UdpSocket_Request_TypeSupportInterface_ptr _duplicate (UdpSocket_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpSocket_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UdpSocket_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpSocket_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpSocket_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UdpSocket_Request_TypeSupportInterface () {};
                ~UdpSocket_Request_TypeSupportInterface () {};
            private:
                UdpSocket_Request_TypeSupportInterface (const UdpSocket_Request_TypeSupportInterface &);
                UdpSocket_Request_TypeSupportInterface & operator = (const UdpSocket_Request_TypeSupportInterface &);
            };

            class  UdpSocket_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UdpSocket_Request_DataWriter_ptr _ptr_type;
                typedef UdpSocket_Request_DataWriter_var _var_type;

                static UdpSocket_Request_DataWriter_ptr _duplicate (UdpSocket_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpSocket_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UdpSocket_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpSocket_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpSocket_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UdpSocket_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UdpSocket_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UdpSocket_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UdpSocket_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UdpSocket_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UdpSocket_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UdpSocket_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UdpSocket_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UdpSocket_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UdpSocket_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UdpSocket_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UdpSocket_Request_& instance_data) = 0;

            protected:
                UdpSocket_Request_DataWriter () {};
                ~UdpSocket_Request_DataWriter () {};
            private:
                UdpSocket_Request_DataWriter (const UdpSocket_Request_DataWriter &);
                UdpSocket_Request_DataWriter & operator = (const UdpSocket_Request_DataWriter &);
            };

            class  UdpSocket_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UdpSocket_Request_DataReader_ptr _ptr_type;
                typedef UdpSocket_Request_DataReader_var _var_type;

                static UdpSocket_Request_DataReader_ptr _duplicate (UdpSocket_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpSocket_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UdpSocket_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpSocket_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpSocket_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UdpSocket_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UdpSocket_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UdpSocket_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UdpSocket_Request_& instance) = 0;

            protected:
                UdpSocket_Request_DataReader () {};
                ~UdpSocket_Request_DataReader () {};
            private:
                UdpSocket_Request_DataReader (const UdpSocket_Request_DataReader &);
                UdpSocket_Request_DataReader & operator = (const UdpSocket_Request_DataReader &);
            };

            class  UdpSocket_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UdpSocket_Request_DataReaderView_ptr _ptr_type;
                typedef UdpSocket_Request_DataReaderView_var _var_type;

                static UdpSocket_Request_DataReaderView_ptr _duplicate (UdpSocket_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpSocket_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UdpSocket_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpSocket_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpSocket_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UdpSocket_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UdpSocket_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UdpSocket_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UdpSocket_Request_& instance) = 0;

            protected:
                UdpSocket_Request_DataReaderView () {};
                ~UdpSocket_Request_DataReaderView () {};
            private:
                UdpSocket_Request_DataReaderView (const UdpSocket_Request_DataReaderView &);
                UdpSocket_Request_DataReaderView & operator = (const UdpSocket_Request_DataReaderView &);
            };
            class UdpSocket_Response_TypeSupportInterface;

            typedef UdpSocket_Response_TypeSupportInterface * UdpSocket_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UdpSocket_Response_TypeSupportInterface> UdpSocket_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UdpSocket_Response_TypeSupportInterface> UdpSocket_Response_TypeSupportInterface_out;


            class UdpSocket_Response_DataWriter;

            typedef UdpSocket_Response_DataWriter * UdpSocket_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UdpSocket_Response_DataWriter> UdpSocket_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < UdpSocket_Response_DataWriter> UdpSocket_Response_DataWriter_out;


            class UdpSocket_Response_DataReader;

            typedef UdpSocket_Response_DataReader * UdpSocket_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UdpSocket_Response_DataReader> UdpSocket_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < UdpSocket_Response_DataReader> UdpSocket_Response_DataReader_out;


            class UdpSocket_Response_DataReaderView;

            typedef UdpSocket_Response_DataReaderView * UdpSocket_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UdpSocket_Response_DataReaderView> UdpSocket_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UdpSocket_Response_DataReaderView> UdpSocket_Response_DataReaderView_out;

            struct UdpSocket_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < UdpSocket_Response_, struct UdpSocket_Response_Seq_uniq_> UdpSocket_Response_Seq;
            typedef DDS_DCPSSequence_var < UdpSocket_Response_Seq> UdpSocket_Response_Seq_var;
            typedef DDS_DCPSSequence_out < UdpSocket_Response_Seq> UdpSocket_Response_Seq_out;

            class  UdpSocket_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UdpSocket_Response_TypeSupportInterface_ptr _ptr_type;
                typedef UdpSocket_Response_TypeSupportInterface_var _var_type;

                static UdpSocket_Response_TypeSupportInterface_ptr _duplicate (UdpSocket_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpSocket_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UdpSocket_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpSocket_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpSocket_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UdpSocket_Response_TypeSupportInterface () {};
                ~UdpSocket_Response_TypeSupportInterface () {};
            private:
                UdpSocket_Response_TypeSupportInterface (const UdpSocket_Response_TypeSupportInterface &);
                UdpSocket_Response_TypeSupportInterface & operator = (const UdpSocket_Response_TypeSupportInterface &);
            };

            class  UdpSocket_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UdpSocket_Response_DataWriter_ptr _ptr_type;
                typedef UdpSocket_Response_DataWriter_var _var_type;

                static UdpSocket_Response_DataWriter_ptr _duplicate (UdpSocket_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpSocket_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UdpSocket_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpSocket_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpSocket_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UdpSocket_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UdpSocket_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UdpSocket_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UdpSocket_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UdpSocket_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UdpSocket_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UdpSocket_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UdpSocket_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UdpSocket_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UdpSocket_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UdpSocket_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UdpSocket_Response_& instance_data) = 0;

            protected:
                UdpSocket_Response_DataWriter () {};
                ~UdpSocket_Response_DataWriter () {};
            private:
                UdpSocket_Response_DataWriter (const UdpSocket_Response_DataWriter &);
                UdpSocket_Response_DataWriter & operator = (const UdpSocket_Response_DataWriter &);
            };

            class  UdpSocket_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UdpSocket_Response_DataReader_ptr _ptr_type;
                typedef UdpSocket_Response_DataReader_var _var_type;

                static UdpSocket_Response_DataReader_ptr _duplicate (UdpSocket_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpSocket_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UdpSocket_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpSocket_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpSocket_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UdpSocket_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UdpSocket_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UdpSocket_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UdpSocket_Response_& instance) = 0;

            protected:
                UdpSocket_Response_DataReader () {};
                ~UdpSocket_Response_DataReader () {};
            private:
                UdpSocket_Response_DataReader (const UdpSocket_Response_DataReader &);
                UdpSocket_Response_DataReader & operator = (const UdpSocket_Response_DataReader &);
            };

            class  UdpSocket_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UdpSocket_Response_DataReaderView_ptr _ptr_type;
                typedef UdpSocket_Response_DataReaderView_var _var_type;

                static UdpSocket_Response_DataReaderView_ptr _duplicate (UdpSocket_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UdpSocket_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UdpSocket_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UdpSocket_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UdpSocket_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UdpSocket_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UdpSocket_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UdpSocket_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UdpSocket_Response_& instance) = 0;

            protected:
                UdpSocket_Response_DataReaderView () {};
                ~UdpSocket_Response_DataReaderView () {};
            private:
                UdpSocket_Response_DataReaderView (const UdpSocket_Response_DataReaderView &);
                UdpSocket_Response_DataReaderView & operator = (const UdpSocket_Response_DataReaderView &);
            };
            class Sample_UdpSocket_Request_TypeSupportInterface;

            typedef Sample_UdpSocket_Request_TypeSupportInterface * Sample_UdpSocket_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_UdpSocket_Request_TypeSupportInterface> Sample_UdpSocket_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_UdpSocket_Request_TypeSupportInterface> Sample_UdpSocket_Request_TypeSupportInterface_out;


            class Sample_UdpSocket_Request_DataWriter;

            typedef Sample_UdpSocket_Request_DataWriter * Sample_UdpSocket_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_UdpSocket_Request_DataWriter> Sample_UdpSocket_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_UdpSocket_Request_DataWriter> Sample_UdpSocket_Request_DataWriter_out;


            class Sample_UdpSocket_Request_DataReader;

            typedef Sample_UdpSocket_Request_DataReader * Sample_UdpSocket_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_UdpSocket_Request_DataReader> Sample_UdpSocket_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_UdpSocket_Request_DataReader> Sample_UdpSocket_Request_DataReader_out;


            class Sample_UdpSocket_Request_DataReaderView;

            typedef Sample_UdpSocket_Request_DataReaderView * Sample_UdpSocket_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_UdpSocket_Request_DataReaderView> Sample_UdpSocket_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_UdpSocket_Request_DataReaderView> Sample_UdpSocket_Request_DataReaderView_out;

            struct Sample_UdpSocket_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_UdpSocket_Request_, struct Sample_UdpSocket_Request_Seq_uniq_> Sample_UdpSocket_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_UdpSocket_Request_Seq> Sample_UdpSocket_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_UdpSocket_Request_Seq> Sample_UdpSocket_Request_Seq_out;

            class  Sample_UdpSocket_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_UdpSocket_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_UdpSocket_Request_TypeSupportInterface_var _var_type;

                static Sample_UdpSocket_Request_TypeSupportInterface_ptr _duplicate (Sample_UdpSocket_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UdpSocket_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UdpSocket_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UdpSocket_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UdpSocket_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_UdpSocket_Request_TypeSupportInterface () {};
                ~Sample_UdpSocket_Request_TypeSupportInterface () {};
            private:
                Sample_UdpSocket_Request_TypeSupportInterface (const Sample_UdpSocket_Request_TypeSupportInterface &);
                Sample_UdpSocket_Request_TypeSupportInterface & operator = (const Sample_UdpSocket_Request_TypeSupportInterface &);
            };

            class  Sample_UdpSocket_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_UdpSocket_Request_DataWriter_ptr _ptr_type;
                typedef Sample_UdpSocket_Request_DataWriter_var _var_type;

                static Sample_UdpSocket_Request_DataWriter_ptr _duplicate (Sample_UdpSocket_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UdpSocket_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UdpSocket_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UdpSocket_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UdpSocket_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_UdpSocket_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_UdpSocket_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_UdpSocket_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_UdpSocket_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_UdpSocket_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_UdpSocket_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_UdpSocket_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_UdpSocket_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_UdpSocket_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_UdpSocket_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_UdpSocket_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UdpSocket_Request_& instance_data) = 0;

            protected:
                Sample_UdpSocket_Request_DataWriter () {};
                ~Sample_UdpSocket_Request_DataWriter () {};
            private:
                Sample_UdpSocket_Request_DataWriter (const Sample_UdpSocket_Request_DataWriter &);
                Sample_UdpSocket_Request_DataWriter & operator = (const Sample_UdpSocket_Request_DataWriter &);
            };

            class  Sample_UdpSocket_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_UdpSocket_Request_DataReader_ptr _ptr_type;
                typedef Sample_UdpSocket_Request_DataReader_var _var_type;

                static Sample_UdpSocket_Request_DataReader_ptr _duplicate (Sample_UdpSocket_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UdpSocket_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UdpSocket_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UdpSocket_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UdpSocket_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_UdpSocket_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_UdpSocket_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_UdpSocket_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UdpSocket_Request_& instance) = 0;

            protected:
                Sample_UdpSocket_Request_DataReader () {};
                ~Sample_UdpSocket_Request_DataReader () {};
            private:
                Sample_UdpSocket_Request_DataReader (const Sample_UdpSocket_Request_DataReader &);
                Sample_UdpSocket_Request_DataReader & operator = (const Sample_UdpSocket_Request_DataReader &);
            };

            class  Sample_UdpSocket_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_UdpSocket_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_UdpSocket_Request_DataReaderView_var _var_type;

                static Sample_UdpSocket_Request_DataReaderView_ptr _duplicate (Sample_UdpSocket_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UdpSocket_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UdpSocket_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UdpSocket_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UdpSocket_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_UdpSocket_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_UdpSocket_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_UdpSocket_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_UdpSocket_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UdpSocket_Request_& instance) = 0;

            protected:
                Sample_UdpSocket_Request_DataReaderView () {};
                ~Sample_UdpSocket_Request_DataReaderView () {};
            private:
                Sample_UdpSocket_Request_DataReaderView (const Sample_UdpSocket_Request_DataReaderView &);
                Sample_UdpSocket_Request_DataReaderView & operator = (const Sample_UdpSocket_Request_DataReaderView &);
            };
            class Sample_UdpSocket_Response_TypeSupportInterface;

            typedef Sample_UdpSocket_Response_TypeSupportInterface * Sample_UdpSocket_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_UdpSocket_Response_TypeSupportInterface> Sample_UdpSocket_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_UdpSocket_Response_TypeSupportInterface> Sample_UdpSocket_Response_TypeSupportInterface_out;


            class Sample_UdpSocket_Response_DataWriter;

            typedef Sample_UdpSocket_Response_DataWriter * Sample_UdpSocket_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_UdpSocket_Response_DataWriter> Sample_UdpSocket_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_UdpSocket_Response_DataWriter> Sample_UdpSocket_Response_DataWriter_out;


            class Sample_UdpSocket_Response_DataReader;

            typedef Sample_UdpSocket_Response_DataReader * Sample_UdpSocket_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_UdpSocket_Response_DataReader> Sample_UdpSocket_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_UdpSocket_Response_DataReader> Sample_UdpSocket_Response_DataReader_out;


            class Sample_UdpSocket_Response_DataReaderView;

            typedef Sample_UdpSocket_Response_DataReaderView * Sample_UdpSocket_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_UdpSocket_Response_DataReaderView> Sample_UdpSocket_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_UdpSocket_Response_DataReaderView> Sample_UdpSocket_Response_DataReaderView_out;

            struct Sample_UdpSocket_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_UdpSocket_Response_, struct Sample_UdpSocket_Response_Seq_uniq_> Sample_UdpSocket_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_UdpSocket_Response_Seq> Sample_UdpSocket_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_UdpSocket_Response_Seq> Sample_UdpSocket_Response_Seq_out;

            class  Sample_UdpSocket_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_UdpSocket_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_UdpSocket_Response_TypeSupportInterface_var _var_type;

                static Sample_UdpSocket_Response_TypeSupportInterface_ptr _duplicate (Sample_UdpSocket_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UdpSocket_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UdpSocket_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UdpSocket_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UdpSocket_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_UdpSocket_Response_TypeSupportInterface () {};
                ~Sample_UdpSocket_Response_TypeSupportInterface () {};
            private:
                Sample_UdpSocket_Response_TypeSupportInterface (const Sample_UdpSocket_Response_TypeSupportInterface &);
                Sample_UdpSocket_Response_TypeSupportInterface & operator = (const Sample_UdpSocket_Response_TypeSupportInterface &);
            };

            class  Sample_UdpSocket_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_UdpSocket_Response_DataWriter_ptr _ptr_type;
                typedef Sample_UdpSocket_Response_DataWriter_var _var_type;

                static Sample_UdpSocket_Response_DataWriter_ptr _duplicate (Sample_UdpSocket_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UdpSocket_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UdpSocket_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UdpSocket_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UdpSocket_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_UdpSocket_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_UdpSocket_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_UdpSocket_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_UdpSocket_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_UdpSocket_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_UdpSocket_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_UdpSocket_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_UdpSocket_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_UdpSocket_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_UdpSocket_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_UdpSocket_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UdpSocket_Response_& instance_data) = 0;

            protected:
                Sample_UdpSocket_Response_DataWriter () {};
                ~Sample_UdpSocket_Response_DataWriter () {};
            private:
                Sample_UdpSocket_Response_DataWriter (const Sample_UdpSocket_Response_DataWriter &);
                Sample_UdpSocket_Response_DataWriter & operator = (const Sample_UdpSocket_Response_DataWriter &);
            };

            class  Sample_UdpSocket_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_UdpSocket_Response_DataReader_ptr _ptr_type;
                typedef Sample_UdpSocket_Response_DataReader_var _var_type;

                static Sample_UdpSocket_Response_DataReader_ptr _duplicate (Sample_UdpSocket_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UdpSocket_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UdpSocket_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UdpSocket_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UdpSocket_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_UdpSocket_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_UdpSocket_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_UdpSocket_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UdpSocket_Response_& instance) = 0;

            protected:
                Sample_UdpSocket_Response_DataReader () {};
                ~Sample_UdpSocket_Response_DataReader () {};
            private:
                Sample_UdpSocket_Response_DataReader (const Sample_UdpSocket_Response_DataReader &);
                Sample_UdpSocket_Response_DataReader & operator = (const Sample_UdpSocket_Response_DataReader &);
            };

            class  Sample_UdpSocket_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_UdpSocket_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_UdpSocket_Response_DataReaderView_var _var_type;

                static Sample_UdpSocket_Response_DataReaderView_ptr _duplicate (Sample_UdpSocket_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_UdpSocket_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_UdpSocket_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_UdpSocket_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_UdpSocket_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_UdpSocket_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_UdpSocket_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_UdpSocket_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_UdpSocket_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_UdpSocket_Response_& instance) = 0;

            protected:
                Sample_UdpSocket_Response_DataReaderView () {};
                ~Sample_UdpSocket_Response_DataReaderView () {};
            private:
                Sample_UdpSocket_Response_DataReaderView (const Sample_UdpSocket_Response_DataReaderView &);
                Sample_UdpSocket_Response_DataReaderView & operator = (const Sample_UdpSocket_Response_DataReaderView &);
            };
        }

    }

}

#endif
