// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from udp_msgs:srv/UdpSend.idl
// generated code does not contain a copyright notice
#include "udp_msgs/srv/udp_send__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

// Include directives for member types
// Member `local_address`
// Member `remote_address`
#include "rosidl_generator_c/string_functions.h"
// Member `data`
#include "rosidl_generator_c/primitives_sequence_functions.h"

bool
udp_msgs__srv__UdpSend_Request__init(udp_msgs__srv__UdpSend_Request * msg)
{
  if (!msg) {
    return false;
  }
  // local_address
  if (!rosidl_generator_c__String__init(&msg->local_address)) {
    udp_msgs__srv__UdpSend_Request__fini(msg);
    return false;
  }
  // local_port
  // remote_address
  if (!rosidl_generator_c__String__init(&msg->remote_address)) {
    udp_msgs__srv__UdpSend_Request__fini(msg);
    return false;
  }
  // remote_port
  // data
  if (!rosidl_generator_c__uint8__Sequence__init(&msg->data, 0)) {
    udp_msgs__srv__UdpSend_Request__fini(msg);
    return false;
  }
  return true;
}

void
udp_msgs__srv__UdpSend_Request__fini(udp_msgs__srv__UdpSend_Request * msg)
{
  if (!msg) {
    return;
  }
  // local_address
  rosidl_generator_c__String__fini(&msg->local_address);
  // local_port
  // remote_address
  rosidl_generator_c__String__fini(&msg->remote_address);
  // remote_port
  // data
  rosidl_generator_c__uint8__Sequence__fini(&msg->data);
}

udp_msgs__srv__UdpSend_Request *
udp_msgs__srv__UdpSend_Request__create()
{
  udp_msgs__srv__UdpSend_Request * msg = (udp_msgs__srv__UdpSend_Request *)malloc(sizeof(udp_msgs__srv__UdpSend_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(udp_msgs__srv__UdpSend_Request));
  bool success = udp_msgs__srv__UdpSend_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
udp_msgs__srv__UdpSend_Request__destroy(udp_msgs__srv__UdpSend_Request * msg)
{
  if (msg) {
    udp_msgs__srv__UdpSend_Request__fini(msg);
  }
  free(msg);
}


bool
udp_msgs__srv__UdpSend_Request__Sequence__init(udp_msgs__srv__UdpSend_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  udp_msgs__srv__UdpSend_Request * data = NULL;
  if (size) {
    data = (udp_msgs__srv__UdpSend_Request *)calloc(size, sizeof(udp_msgs__srv__UdpSend_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = udp_msgs__srv__UdpSend_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        udp_msgs__srv__UdpSend_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
udp_msgs__srv__UdpSend_Request__Sequence__fini(udp_msgs__srv__UdpSend_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      udp_msgs__srv__UdpSend_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

udp_msgs__srv__UdpSend_Request__Sequence *
udp_msgs__srv__UdpSend_Request__Sequence__create(size_t size)
{
  udp_msgs__srv__UdpSend_Request__Sequence * array = (udp_msgs__srv__UdpSend_Request__Sequence *)malloc(sizeof(udp_msgs__srv__UdpSend_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = udp_msgs__srv__UdpSend_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
udp_msgs__srv__UdpSend_Request__Sequence__destroy(udp_msgs__srv__UdpSend_Request__Sequence * array)
{
  if (array) {
    udp_msgs__srv__UdpSend_Request__Sequence__fini(array);
  }
  free(array);
}


bool
udp_msgs__srv__UdpSend_Response__init(udp_msgs__srv__UdpSend_Response * msg)
{
  if (!msg) {
    return false;
  }
  // sent
  return true;
}

void
udp_msgs__srv__UdpSend_Response__fini(udp_msgs__srv__UdpSend_Response * msg)
{
  if (!msg) {
    return;
  }
  // sent
}

udp_msgs__srv__UdpSend_Response *
udp_msgs__srv__UdpSend_Response__create()
{
  udp_msgs__srv__UdpSend_Response * msg = (udp_msgs__srv__UdpSend_Response *)malloc(sizeof(udp_msgs__srv__UdpSend_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(udp_msgs__srv__UdpSend_Response));
  bool success = udp_msgs__srv__UdpSend_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
udp_msgs__srv__UdpSend_Response__destroy(udp_msgs__srv__UdpSend_Response * msg)
{
  if (msg) {
    udp_msgs__srv__UdpSend_Response__fini(msg);
  }
  free(msg);
}


bool
udp_msgs__srv__UdpSend_Response__Sequence__init(udp_msgs__srv__UdpSend_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  udp_msgs__srv__UdpSend_Response * data = NULL;
  if (size) {
    data = (udp_msgs__srv__UdpSend_Response *)calloc(size, sizeof(udp_msgs__srv__UdpSend_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = udp_msgs__srv__UdpSend_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        udp_msgs__srv__UdpSend_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
udp_msgs__srv__UdpSend_Response__Sequence__fini(udp_msgs__srv__UdpSend_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      udp_msgs__srv__UdpSend_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

udp_msgs__srv__UdpSend_Response__Sequence *
udp_msgs__srv__UdpSend_Response__Sequence__create(size_t size)
{
  udp_msgs__srv__UdpSend_Response__Sequence * array = (udp_msgs__srv__UdpSend_Response__Sequence *)malloc(sizeof(udp_msgs__srv__UdpSend_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = udp_msgs__srv__UdpSend_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
udp_msgs__srv__UdpSend_Response__Sequence__destroy(udp_msgs__srv__UdpSend_Response__Sequence * array)
{
  if (array) {
    udp_msgs__srv__UdpSend_Response__Sequence__fini(array);
  }
  free(array);
}
