// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from udp_msgs:msg/UdpPacket.idl
// generated code does not contain a copyright notice
#include "udp_msgs/msg/udp_packet__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `address`
#include "rosidl_generator_c/string_functions.h"
// Member `data`
#include "rosidl_generator_c/primitives_sequence_functions.h"

bool
udp_msgs__msg__UdpPacket__init(udp_msgs__msg__UdpPacket * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    udp_msgs__msg__UdpPacket__fini(msg);
    return false;
  }
  // address
  if (!rosidl_generator_c__String__init(&msg->address)) {
    udp_msgs__msg__UdpPacket__fini(msg);
    return false;
  }
  // src_port
  // data
  if (!rosidl_generator_c__uint8__Sequence__init(&msg->data, 0)) {
    udp_msgs__msg__UdpPacket__fini(msg);
    return false;
  }
  return true;
}

void
udp_msgs__msg__UdpPacket__fini(udp_msgs__msg__UdpPacket * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // address
  rosidl_generator_c__String__fini(&msg->address);
  // src_port
  // data
  rosidl_generator_c__uint8__Sequence__fini(&msg->data);
}

udp_msgs__msg__UdpPacket *
udp_msgs__msg__UdpPacket__create()
{
  udp_msgs__msg__UdpPacket * msg = (udp_msgs__msg__UdpPacket *)malloc(sizeof(udp_msgs__msg__UdpPacket));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(udp_msgs__msg__UdpPacket));
  bool success = udp_msgs__msg__UdpPacket__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
udp_msgs__msg__UdpPacket__destroy(udp_msgs__msg__UdpPacket * msg)
{
  if (msg) {
    udp_msgs__msg__UdpPacket__fini(msg);
  }
  free(msg);
}


bool
udp_msgs__msg__UdpPacket__Sequence__init(udp_msgs__msg__UdpPacket__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  udp_msgs__msg__UdpPacket * data = NULL;
  if (size) {
    data = (udp_msgs__msg__UdpPacket *)calloc(size, sizeof(udp_msgs__msg__UdpPacket));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = udp_msgs__msg__UdpPacket__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        udp_msgs__msg__UdpPacket__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
udp_msgs__msg__UdpPacket__Sequence__fini(udp_msgs__msg__UdpPacket__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      udp_msgs__msg__UdpPacket__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

udp_msgs__msg__UdpPacket__Sequence *
udp_msgs__msg__UdpPacket__Sequence__create(size_t size)
{
  udp_msgs__msg__UdpPacket__Sequence * array = (udp_msgs__msg__UdpPacket__Sequence *)malloc(sizeof(udp_msgs__msg__UdpPacket__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = udp_msgs__msg__UdpPacket__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
udp_msgs__msg__UdpPacket__Sequence__destroy(udp_msgs__msg__UdpPacket__Sequence * array)
{
  if (array) {
    udp_msgs__msg__UdpPacket__Sequence__fini(array);
  }
  free(array);
}
